=== debian/changelog ===
libdecaf (1.0.1-2) unstable; urgency=medium

  * Source-Only Upload (Closes: #1014832)
  * Add Salsa CI config

 -- Bernhard Schmidt <berni@debian.org>  Sun, 24 Jul 2022 16:44:57 +0200

libdecaf (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #893058)

 -- Dennis Filder <d.filder@web.de>  Sat, 09 Apr 2022 15:05:57 +0200
