=== debian/control ===
Source: libdecaf
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Bernhard Schmidt <berni@debian.org>,
           Dennis Filder <d.filder@web.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen <!nodoc>,
# a code generator is written in Python 2.7 and thus always
# needed
               python2.7,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Section: libs
Homepage: https://ed448goldilocks.sourceforge.io/
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf.git

Package: libdecaf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdecaf0 (= ${binary:Version}), ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains files necessary to compile software written
 against libdecaf.

Package: libdecaf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains the runtime shared library.

Package: libdecaf-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ed448-Goldilocks-based elliptic curve cryptography library
 Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
 Michael Hamburg in 2015 and is suitable for fast cryptographic
 operation with small keysizes.
 .
 This package contains the developer documentation.
