=== debian/changelog ===
libdecaf (1.0.2-3) unstable; urgency=medium

  * Team upload.
  * debian/gbp.conf: use upstream tags
  * rise min required version for cmake (Closes: #1113136)
  * clean all pyc files (Closes: #1045705)

 -- Victor Seva <vseva@debian.org>  Sun, 02 Nov 2025 20:32:08 +0100

libdecaf (1.0.2-2) unstable; urgency=medium

  * Upload to unstable (Closes: #1023238)

 -- Bernhard Schmidt <berni@debian.org>  Thu, 03 Nov 2022 09:31:51 +0100

libdecaf (1.0.2-1) experimental; urgency=medium

  * New upstream release 1.0.2 containing a security fix.
  * Build with Python3 now.
  * Make arch/indep builds work separately and honour nodoc build profile.

 -- Dennis Filder <d.filder@web.de>  Mon, 03 Oct 2022 21:57:20 +0200
