=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
            Dennis Filder <d.filder@web.de>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               doxygen <!nodoc>,
-# a code generator is written in Python 2.7 and thus always
-# needed
-               python2.7,
+               python3,
+Build-Depends-Indep: doxygen <!nodoc>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://ed448goldilocks.sourceforge.io/
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/libdecaf.git
+Description: Ed448-Goldilocks-based elliptic curve cryptography library
 
 Package: libdecaf-dev
 Section: libdevel
@@ -44,7 +43,8 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Build-Profiles: <!nodoc>
+Depends: ${misc:Depends}
 Description: Ed448-Goldilocks-based elliptic curve cryptography library
  Ed448-Goldilocks is an Edwards-form elliptic curve proposed by
  Michael Hamburg in 2015 and is suitable for fast cryptographic
